<template>
<div>
    <app-layout>
        <template #header><inertia-link href="/displays">Display</inertia-link>: {{ display.name }}</template>
        <panel>
            <div class="mx-4 my-1">
                Owner: {{ display.joiner.name }}
            </div>
            <div class="mx-4 my-1" v-if="display.organization">
                Organization: {{ display.organization.name || "Personal" }}
            </div>
            <div class="mx-4 my-1">
                Group: {{ (display.group && display.group.name)? display.group.name : "None" }}
            </div>
            <div class="mx-4 my-1">
                Display Group: {{ (display.display_group && display.display_group.name)? display.display_group.name : "None" }}
            </div>
            <div class="mx-4 my-1">
                <div>Registrations <feather type="plus" class="h-3 text-green-500" @click="newRegOpen = true"/></div>
                <ol class="ml-6">
                    <li v-for="reg in display.registrations" :key="reg.id">
                        <feather type="x" class="h-3 text-red-500" title="remove" @click="removeReg(reg.id)"/>
                        {{ reg.code }} - Last seen {{ (reg.heartbeat_at)?  dayjs(reg.heartbeat_at).format('lll'): "Never" }}
                    </li>
                </ol>
            </div>
        </panel>
    </app-layout>
    <dialog-modal :show="newRegOpen" @close="newRegOpen = false">
        <template #title>Add Registration</template>
        <div class="mb-4">
            <x-label class="mb-2">Display Code</x-label>
            <x-input :value="regForm.code" @input="inputCode" :filter="filterCode" placeholder="ABC123" class="py-2 px-3 w-full"/>
            <div class="text-sm text-gray-600 dark:text-gray-400 mt-1">The six-digit code is found on the bottom right of the display.</div>
        </div>
        <template #footer><button class="bg-green-500 rounded px-2 py-1" @click="addReg">Add</button></template>
    </dialog-modal>
</div>
</template>

<script>
import dayjs from 'dayjs'
import LocalizedFormat from 'dayjs/plugin/localizedFormat'
dayjs.extend(LocalizedFormat)

export default {
    props: {
        display: Object,
    },
    data() {
        return {
            newRegOpen: false,
            regForm: this.$inertia.form({
                code: this.code,
            }, {
                bag: 'newReg',
                resetOnSuccess: true,
            }),
        }
    },
    methods: {
        dayjs,
        removeReg(id){
            this.$inertia.delete("/displays/" + this.display.id + "/registrations/" + id);
        },
        filterCode(e){ // keydown event
            console.log(e);
            if(e.key.length > 1) return;
            if(this.regForm.code.length >= 6) e.preventDefault();
            if(!('ABCDEFGHJKMNPQRSTUVWXYZ23456789@#$%&'.split('').includes(e.key.toUpperCase()))) e.preventDefault();
        },
        inputCode(val){
            this.regForm.code = val.toUpperCase();
        },
        addReg(){
            this.regForm.post("/displays/" + this.display.id + "/registrations");
            this.newRegOpen = false;
        },
    },
}
</script>
